<template>
	<section class="settings_main p-3">
		<div class="settings_content pr-3">
			<div class="settings_content_inr base_block">
				<div class="settings_panel p-3">
					<div class="settings_panel_ttl">
						<div class="txt">{{$store.state.locale.roles}}</div>
						<button
								type="button"
								class="login_main_sign_btn bt"
								data-toggle="modal"
								data-target="#roleModal"
								@click="roleActionType = 1"
								v-if="can('settings_role', 'Edit')"
						>
							{{$store.state.locale.addRoles}}
						</button>
					</div>

					<div class="settings_panel_cnt">
						<div class="table-responsive settings_content_tb">
							<table class="table table-striped table-hover">
								<thead>
								<tr>
									<th scope="col">Id</th>
									<th scope="col">{{$store.state.locale.roleName}}</th>
									<th scope="col">{{$store.state.locale.comment}}</th>
									<th scope="col">{{$store.state.locale.modules}}</th>
									<th scope="col">{{$store.state.locale.users}}</th>
									<th scope="col" class="w-40"></th>
								</tr>
								</thead>

								<tbody>
								<tr v-for="item in roleList">
									<td>{{ item.id }}</td>
									<td>{{ item.name }}</td>
									<td>{{ item.comment }}</td>
									<td>{{ item.moduleCount }} modules</td>
									<td>{{ item.userCount }} users</td>
									<td>
										<div class="btn-group">
											<button type="button" class="icon-btn" @click="roleDetailsId = item.id; RoleDetails();">
												<i class="mdi mdi-eye"></i>
											</button>

											<button type="button" class="icon-btn" @click="RoleRead(item.id); roleActionType = 2" v-if="can('settings_role', 'Edit')">
												<i class="mdi mdi-pencil"></i>
											</button>
											<button type="button" class="icon-btn" @click="RoleRead(item.id); roleActionType = 3" v-if="can('settings_role', 'Edit')">
												<i class="mdi mdi-delete text-danger"></i>
											</button>
										</div>
									</td>
								</tr>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
		</div>


		<div class="settings_aside" v-if="roleSelected">
			<div class="settings_aside_inr base_block">
				<div class="settings_aside_hd">
					<div class="txt">{{ roleSelected.name }}</div>
					<div class="settings_aside_tab_btn">
						<button type="button" class="bt" :class="{active: roleType === 1}" @click="roleType = 1"><i class="mdi mdi-account"></i></button>
						<button type="button" class="bt" :class="{active: roleType === 2}" @click="roleType = 2"><i class="mdi mdi-puzzle"></i></button>
					</div>
				</div>

				<div class="settings_aside_bd">
					<div class="settings_aside_tab_pane" v-if="roleType === 1">
						<div class="settings_aside_user">
							<ul class="settings_aside_user_ls">
								<li v-for="item in roleUserList">
									<div class="txt">{{ item.userName }}</div>

									<button type="button" class="settings_btn_delete" @click="RoleUserDelete(item.id)" v-if="can('settings_role', 'Edit')">
										<i class="mdi mdi-delete"></i>
									</button>
								</li>
							</ul>
						</div>


						<div class="cplt_table_ft">
							<div style="margin-top: 16px;" class="call_message_ft d-flex justify-content-center" v-if="(pageCount > 1)">
								<paginate
										:page-count="pageCount"
										:page-range="3"
										:margin-pages="1"
										:click-handler="RoleDetails"
										container-class="pagination base_pagination"
										page-class="page-item"
										prev-class="page-item ctrl"
										next-class="page-item ctrl"
										page-link-class="page-link"
										prev-link-class="page-link"
										next-link-class="page-link"
										prev-text="<i class='mdi mdi-chevron-left'></i>"
										next-text="<i class='mdi mdi-chevron-right'></i>"
								>
								</paginate>
							</div>
						</div>


					</div>


					<div class="settings_aside_tab_pane" v-if="roleType === 2">
						<div class="settings_aside_module">
							<table class="settings_aside_module_tb">
								<thead>
								<tr>
									<td>{{$store.state.locale.modules}}</td>
									<td>{{$store.state.locale.action}}</td>
									<td width="50px" v-if="can('settings_role', 'Edit')"></td>
								</tr>
								</thead>

								<tbody>
								<tr v-for="item in roleModuleList">
									<td>
										<div class="name">{{ item.moduleName }}</div>
									</td>
									<td>{{ item.actionName }}</td>
									<td v-if="can('settings_role', 'Edit')">
										<button type="button" class="settings_btn_delete" @click="RoleModuleDelete(item.id)">
											<i class="mdi mdi-delete"></i>
										</button>
									</td>
								</tr>
								</tbody>
							</table>
						</div>
					</div>
				</div>

				<div class="settings_aside_ft" v-if="can('settings_role', 'Edit')">
					<button type="button" class="btn login_main_sign_btn settings_aside_btn" data-toggle="modal" data-target="#userModuleModal"
							@click="ListUsers" v-if="roleType === 1">Add Users</button>
					<button type="button" class="btn login_main_sign_btn settings_aside_btn" data-toggle="modal" data-target="#userModuleModal"
							@click="ListModuleAction" v-if="roleType === 2">Add Modules</button>
				</div>
			</div>
		</div>



		<div class="modal fade base_modal" id="roleModal">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<div class="base_modal_ttl">{{$store.state.locale.roles}}</div>
					</div>

					<div class="modal-body">
						<form v-on:submit.prevent="onSubmit">
							<div class="form-group">
								<label class="base_label">{{$store.state.locale.roleName}}</label>
								<input type="text" class="form-control base_input" placeholder="Name" v-model="roleModel.name" :disabled="roleActionType === 3" required>
							</div>

							<div class="form-group">
								<label class="base_label">{{$store.state.locale.comment}}</label>
								<textarea class="form-control base_input" rows="5" placeholder="Comment" v-model="roleModel.comment" :disabled="roleActionType === 3"></textarea>
							</div>

							<div>
								<button type="submit" class="login_main_sign_btn base_modal_btn" v-if="roleActionType === 1" @click="RoleCreate">Add</button>
								<button type="submit" class="login_main_sign_btn base_modal_btn success" v-if="roleActionType === 2" @click="RoleUpdate">Update</button>
								<button type="submit" class="login_main_sign_btn base_modal_btn danger" v-if="roleActionType === 3" @click="RoleDelete">Delete</button>
							</div>
						</form>
					</div>
				</div>
			</div>
		</div>

		<div class="modal fade base_modal" id="userModuleModal">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<div class="base_modal_ttl" v-if="roleType === 1">{{$store.state.locale.add}} {{$store.state.locale.users}}</div>
						<div class="base_modal_ttl" v-if="roleType === 2">{{$store.state.locale.add}} {{$store.state.locale.modules}}</div>
					</div>

					<div class="modal-body">
						<div v-if="roleType === 1">
							<div class="form-group">
								<label class="base_label">{{$store.state.locale.userList}}</label>
								<select class="form-control base_input" v-model="userSelected">
									<option v-for="item in userList" :value="item.id">{{ item.fio }}</option>
								</select>
							</div>

							<div class="alert alert-danger" v-if="errorMessage !== ''">{{ errorMessage }}</div>
						</div>

						<div v-if="roleType === 2">
							<div class="form-group">
								<label class="base_label">{{$store.state.locale.moduleList}}</label>
								<select class="form-control base_input" v-model="moduleSelected">
									<option v-for="item in moduleList" :value="item.id">{{ item.name }}</option>
								</select>
							</div>

							<div class="form-group">
								<label class="base_label">{{$store.state.locale.actionList}}</label>
								<select class="form-control base_input" v-model="actionSelected">
									<option v-for="item in actionList" :value="item.id">{{ item.comment }}</option>
								</select>
							</div>

							<div class="alert alert-danger" v-if="errorMessage !== ''">{{ errorMessage }}</div>
						</div>
					</div>

					<div class="modal-footer">
						<button type="button" class="login_main_sign_btn base_modal_btn" v-if="roleType === 1" @click="RoleUserCreate">{{$store.state.locale.add}}</button>
						<button type="button" class="login_main_sign_btn base_modal_btn" v-if="roleType === 2" @click="RoleModuleCreate">{{$store.state.locale.add}}</button>
					</div>


				</div>
			</div>
		</div>
	</section>
</template>

<style></style>

<script src="./script.js"></script>